=== debian/changelog ===
ros-eloquent-rclcpp (0.8.5-1bionic) bionic; urgency=high

  * Warn about unused result of add_on_set_parameters_callback (#1238 <https://github.com/ros2/rclcpp/issues/1238>) (#1243 <https://github.com/ros2/rclcpp/issues/1243>)
  * fix exception message on rcl_clock_init. (#1194 <https://github.com/ros2/rclcpp/issues/1194>)
  * Check if context is valid when looping in spin_some (#1167 <https://github.com/ros2/rclcpp/issues/1167>)
  * Fix spin_until_future_complete: check spinning value (#1023 <https://github.com/ros2/rclcpp/issues/1023>)
  * Fix lock-order-inversion (potential deadlock) (#1135 <https://github.com/ros2/rclcpp/issues/1135>) (#1137 <https://github.com/ros2/rclcpp/issues/1137>)
  * Don't specify calling convention in std::_Binder template (#952 <https://github.com/ros2/rclcpp/issues/952>) (#1006 <https://github.com/ros2/rclcpp/issues/1006>)
  * Add missing service callback registration tracepoint (#986 <https://github.com/ros2/rclcpp/issues/986>) (#1004 <https://github.com/ros2/rclcpp/issues/1004>)
  * Allow node clock use in logging macros (#969 <https://github.com/ros2/rclcpp/issues/969>) (#970 <https://github.com/ros2/rclcpp/issues/970>) (#981 <https://github.com/ros2/rclcpp/issues/981>)
  * Complete published event message when declaring a parameter (#928 <https://github.com/ros2/rclcpp/issues/928>) (#966 <https://github.com/ros2/rclcpp/issues/966>)
  * Contributors: Christophe Bedard, DongheeYe, Ivan Santiago Paunovic, Jacob Perron, Sean Kelly, Shane Loretz, tomoya

 -- Dirk Thomas <dthomas@osrfoundation.org>  Fri, 04 Dec 2020 06:00:00 -0000

ros-eloquent-rclcpp (0.8.4-1bionic) bionic; urgency=high

  * Intra-process subscriber should use RMW actual qos (ros2`#913 <https://github.com/ros2/rclcpp/issues/913>`_) (#914 <https://github.com/ros2/rclcpp/issues/914>) (#965 <https://github.com/ros2/rclcpp/issues/965>)
  * Contributors: Todd Malsbary

 -- Dirk Thomas <dthomas@osrfoundation.org>  Fri, 17 Jan 2020 06:00:00 -0000

ros-eloquent-rclcpp (0.8.3-1bionic) bionic; urgency=high



 -- Dirk Thomas <dthomas@osrfoundation.org>  Tue, 19 Nov 2019 06:00:00 -0000

ros-eloquent-rclcpp (0.8.2-1bionic) bionic; urgency=high

  * Updated tracing logic to match changes in rclcpp's intra-process system (#918 <https://github.com/ros2/rclcpp/issues/918>)
  * Fixed a bug that prevented the ``shutdown_on_sigint`` option to not work correctly (#850 <https://github.com/ros2/rclcpp/issues/850>)
  * Added support for STREAM logging macros (#926 <https://github.com/ros2/rclcpp/issues/926>)
  * Relaxed multithreaded test constraint (#907 <https://github.com/ros2/rclcpp/issues/907>)
  * Contributors: Anas Abou Allaban, Christophe Bedard, Dirk Thomas, alexfneves

 -- Dirk Thomas <dthomas@osrfoundation.org>  Mon, 18 Nov 2019 06:00:00 -0000

ros-eloquent-rclcpp (0.8.1-1bionic) bionic; urgency=high

  * De-flake tests for rmw_connext (#899 <https://github.com/ros2/rclcpp/issues/899>)
  * rename return functions for loaned messages (#896 <https://github.com/ros2/rclcpp/issues/896>)
  * Enable throttling logs (#879 <https://github.com/ros2/rclcpp/issues/879>)
  * New Intra-Process Communication (#778 <https://github.com/ros2/rclcpp/issues/778>)
  * Instrumentation update (#789 <https://github.com/ros2/rclcpp/issues/789>)
  * Zero copy api (#864 <https://github.com/ros2/rclcpp/issues/864>)
  * Drop rclcpp remove_ros_arguments_null test case. (#894 <https://github.com/ros2/rclcpp/issues/894>)
  * add mechanism to pass rmw impl specific payloads during pub/sub creation (#882 <https://github.com/ros2/rclcpp/issues/882>)
  * make get_actual_qos return a rclcpp::QoS (#883 <https://github.com/ros2/rclcpp/issues/883>)
  * Fix Compiler Warning (#881 <https://github.com/ros2/rclcpp/issues/881>)
  * Add callback handler for use_sim_time parameter #802 <https://github.com/ros2/rclcpp/issues/802> (#875 <https://github.com/ros2/rclcpp/issues/875>)
  * Contributors: Alberto Soragna, Brian Marchi, Hunter L. Allen, Ingo Lütkebohle, Karsten Knese, Michael Carroll, Michel Hidalgo, William Woodall

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 23 Oct 2019 05:00:00 -0000

ros-eloquent-rclcpp (0.8.0-1bionic) bionic; urgency=high

  * clean up publisher and subscription creation logic (#867 <https://github.com/ros2/rclcpp/issues/867>)
  * Take parameter overrides provided through the CLI. (#865 <https://github.com/ros2/rclcpp/issues/865>)
  * add more context to exception message (#858 <https://github.com/ros2/rclcpp/issues/858>)
  * remove features and related code which were deprecated in dashing (#852 <https://github.com/ros2/rclcpp/issues/852>)
  * check valid timer handler 1st to reduce the time window for scan. (#841 <https://github.com/ros2/rclcpp/issues/841>)
  * Add throwing parameter name if parameter is not set (#833 <https://github.com/ros2/rclcpp/issues/833>)
  * Fix typo in deprecated warning. (#848 <https://github.com/ros2/rclcpp/issues/848>)
  * Fail on invalid and unknown ROS specific arguments (#842 <https://github.com/ros2/rclcpp/issues/842>)
  * Force explicit --ros-args in NodeOptions::arguments(). (#845 <https://github.com/ros2/rclcpp/issues/845>)
  * Use of -r/--remap flags where appropriate. (#834 <https://github.com/ros2/rclcpp/issues/834>)
  * Fix hang with timers in MultiThreadedExecutor (#835 <https://github.com/ros2/rclcpp/issues/835>) (#836 <https://github.com/ros2/rclcpp/issues/836>)
  * add mutex in add/remove_node and wait_for_work to protect concurrent use/change of memory_strategy_ (#837 <https://github.com/ros2/rclcpp/issues/837>)
  * Crash in callback group pointer vector iterator (#814 <https://github.com/ros2/rclcpp/issues/814>)
  * Wrap documentation examples in code blocks (#830 <https://github.com/ros2/rclcpp/issues/830>)
  * add callback group as member variable and constructor arg (#811 <https://github.com/ros2/rclcpp/issues/811>)
  * Fix get_node_interfaces functions taking a pointer (#821 <https://github.com/ros2/rclcpp/issues/821>)

