=== debian/control ===
Source: ros-eloquent-rclcpp
Section: misc
Priority: optional
Maintainer: Dirk Thomas <dthomas@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-eloquent-ament-cmake-gmock, ros-eloquent-ament-cmake-gtest, ros-eloquent-ament-cmake-ros, ros-eloquent-ament-lint-auto, ros-eloquent-ament-lint-common, ros-eloquent-builtin-interfaces, ros-eloquent-rcl, ros-eloquent-rcl-interfaces, ros-eloquent-rcl-yaml-param-parser, ros-eloquent-rcpputils, ros-eloquent-rmw, ros-eloquent-rmw-implementation, ros-eloquent-rmw-implementation-cmake, ros-eloquent-rosgraph-msgs, ros-eloquent-rosidl-generator-cpp, ros-eloquent-rosidl-typesupport-c, ros-eloquent-rosidl-typesupport-cpp, ros-eloquent-test-msgs, ros-eloquent-tracetools, ros-eloquent-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-eloquent-rclcpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-eloquent-ament-cmake, ros-eloquent-builtin-interfaces, ros-eloquent-rcl, ros-eloquent-rcl-interfaces, ros-eloquent-rcl-yaml-param-parser, ros-eloquent-rcpputils, ros-eloquent-rmw, ros-eloquent-rmw-implementation, ros-eloquent-rosgraph-msgs, ros-eloquent-rosidl-generator-cpp, ros-eloquent-rosidl-typesupport-c, ros-eloquent-rosidl-typesupport-cpp, ros-eloquent-tracetools, ros-eloquent-ros-workspace
Description: The ROS client library in C++.
